import "./PgProceduresPlugin.js";
import "graphile-config";
import type { PgSelectArgumentSpec, PgSource, PgSourceParameter, PgTypeCodec } from "@dataplan/pg";
import type { ExecutableStep, FieldArgs } from "grafast";
import type { GraphQLInputType } from "graphql";
import type { SQL } from "pg-sql2";
declare const $$rootQuery: unique symbol;
declare const $$rootMutation: unique symbol;
declare const $$computed: unique symbol;
declare global {
    namespace GraphileBuild {
        interface Build {
            pgGetArgDetailsFromParameters(source: PgSource<any, any, any, any>, parameters?: PgSourceParameter[]): {
                makeFieldArgs(): {
                    [graphqlArgName: string]: {
                        type: GraphQLInputType;
                        description?: string;
                    };
                };
                makeArgs(args: FieldArgs, path?: string[]): PgSelectArgumentSpec[];
                argDetails: Array<{
                    graphqlArgName: string;
                    postgresArgName: string | null;
                    pgCodec: PgTypeCodec<any, any, any, any>;
                    inputType: GraphQLInputType;
                    required: boolean;
                }>;
                makeExpression(opts: {
                    $placeholderable: {
                        placeholder($step: ExecutableStep, codec: PgTypeCodec<any, any, any, any>): SQL;
                    };
                    source: PgSource<any, any, any, any>;
                    fieldArgs: FieldArgs;
                    path?: string[];
                    initialArgs?: SQL[];
                }): SQL;
            };
        }
        interface InflectionCustomFieldProcedureDetails {
            source: PgSource<any, any, any, PgSourceParameter[]>;
        }
        interface InflectionCustomFieldArgumentDetails {
            source: PgSource<any, any, any, PgSourceParameter[]>;
            param: PgSourceParameter;
            index: number;
        }
        interface InflectionCustomFieldMutationResult {
            source: PgSource<any, any, any, PgSourceParameter[]>;
            returnGraphQLTypeName: string;
        }
        interface Inflection {
            _functionName(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            customMutationField(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            customMutationPayload(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            customMutationInput(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            customQueryField(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            customQueryConnectionField(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            customQueryListField(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            computedColumnField(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            computedColumnConnectionField(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            computedColumnListField(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            argument(this: Inflection, details: InflectionCustomFieldArgumentDetails): string;
            recordFunctionConnectionType(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            scalarFunctionConnectionType(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            recordFunctionEdgeType(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            scalarFunctionEdgeType(this: Inflection, details: InflectionCustomFieldProcedureDetails): string;
            functionMutationResultFieldName(this: Inflection, details: InflectionCustomFieldMutationResult): string;
        }
    }
}
declare global {
    namespace GraphileBuild {
        interface Build {
            [$$rootQuery]: Array<PgSource<any, any, any, any>>;
            [$$rootMutation]: Array<PgSource<any, any, any, any>>;
            [$$computed]: Map<PgTypeCodec<any, any, any, any>, Array<PgSource<any, any, any, any>>>;
        }
    }
}
export declare const PgCustomTypeFieldPlugin: GraphileConfig.Plugin;
export {};
//# sourceMappingURL=PgCustomTypeFieldPlugin.d.ts.map