import type { PgSmartTagsDict } from "pg-introspection";
export declare function tagToString(str: undefined | null | boolean | string | (string | boolean)[]): string | undefined;
export declare function addBehaviorToTags(tags: Partial<PgSmartTagsDict>, behavior: string, prepend?: boolean): void;
export declare function parseSmartTagsOptsString<TParamName extends string = string>(optsString: string | true | (string | true)[] | undefined, leading?: number): {
    args: string[];
    params: { [paramName in TParamName]?: string | undefined; };
};
export declare function parseDatabaseIdentifierFromSmartTag<TExpectedLength extends number>(identifier: string, expectedLength: TExpectedLength, fallbackNamespace?: string): TExpectedLength extends 1 ? [string] : TExpectedLength extends 2 ? [string, string] : TExpectedLength extends 3 ? [string, string, string] : string[];
/**
 * Makes safe identifiers
 */
export declare class Idents {
    idents: Set<string>;
    /**
     * Don't allow using these identifiers (presumably because they're already in use.
     */
    forbid(identifiers: string[]): void;
    makeSafeIdentifier(str: string): string;
}
//# sourceMappingURL=utils.d.ts.map